#include <jni.h>      /* Java Native Interface headers */
#include "Bessel.h"   /* Auto-generated header created by javah -jni */

#include <nag.h>      /* NAG C Library headers */
#include <nags.h>

/* Our C definition of the function s17acc declared in Bessel.java */
JNIEXPORT jdouble JNICALL
Java_Bessel_s17acc(JNIEnv *env, jobject obj, jdouble x)
{
  double y = 0.0;
  static NagError fail;

  /* Tell the routine we want no output messages on failure */
  fail.print = Nag_FALSE;

  /* Call the Y0(x) Bessel function s17acc */
  y = s17acc(x, &fail);

  if (fail.code != 0)
    printf("Error: s17acc returned fail code %d for argument %g\n",
           fail.code, x);

  return y;
}
